/*
 *	QuelleCode fuer PsxRead & PsxWrite
 *
 *		Ron Moore's Versions,
 *		Maerz, 1993.
 */
 

#include <helios.h>
#include <stdio.h>
#include <posix.h>
#include <errno.h>
#include "PsxIO.h"

int PsxRead(  int fd, char *buf, unsigned nbyte )
{
    int	bytes_so_far 	= 0;
    int	bytes_this_time = 0;
    
    while (bytes_so_far < nbyte ) {
	bytes_this_time = read( fd,
			       buf,
			       (nbyte - bytes_so_far));
	
	if (bytes_this_time < 0) {
	    if (errno == EINTR)
	      continue;
	    return( bytes_this_time );
	}
	else {
	    bytes_so_far += bytes_this_time;
	    buf          += bytes_this_time;
	}
    }
    return (bytes_so_far);
} /* end of PsxRead */

int PsxWrite( int fd, char *buf, unsigned nbyte )
{
    int	bytes_so_far 	= 0;
    int	bytes_this_time = 0;
    
    while (bytes_so_far < nbyte) {
	bytes_this_time = write( fd,
				buf,
				(nbyte - bytes_so_far));
	
	if (bytes_this_time < 0) {
	    if (errno == EINTR)
	      continue;
	    return (bytes_this_time);
	}
	else {
	    bytes_so_far += bytes_this_time;
	    buf          += bytes_this_time;
	}
    }
    return (bytes_so_far);
} /* end of PsxWrite */

  
/* eof */

